Attribute VB_Name = "mdUnload"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdUnload.bas                                           *
'*Author:  Valeria Olivati - c/o Funambol - Pavia - Italy       *
'*                                                              *
'*This module contains all the functions used during the unload *
'*procedure for the Project.                                    *
'*These functions were the last actions done before closing the *
'*program: closing all the opened files and logoff from MAPI    *
'*session.                                                      *
'****************************************************************

Option Explicit

Public Sub closeProgram()

Dim I As Integer

On Error GoTo closeProgram_Err

logToDebug "closing procedure"

Close 'close all opened files

'close the Outlook MAPI Session opened
If Not mdVariables.nameSpace Is Nothing Then
    mdVariables.nameSpace.Logoff
    logToDebug "Logged off; reset global variables"
Else
    logToDebug "No active session"
End If

Dim dimArray As Long


'read the folders arrays in order to seach for the not selected ones
'to compare with the existent disk folders.
'If found a folder not currently selected, it will be deleted

dimArray = -1
dimArray = UBound(mdVariables.calendarFolders)
For I = 0 To dimArray
    If Not mdVariables.calendarFolders(I).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.calendarFolders(I).EntryID) Then
                ChDir mdVariables.calendarFolders(I).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.calendarFolders(I).EntryID
        End If
    End If
Next I
dimArray = -1
dimArray = UBound(mdVariables.contactsFolders)
For I = 0 To dimArray
    If Not mdVariables.contactsFolders(I).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.contactsFolders(I).EntryID) Then
                ChDir mdVariables.contactsFolders(I).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.contactsFolders(I).EntryID
        End If
    End If
Next I

dimArray = -1
dimArray = UBound(mdVariables.mailFolders)
For I = 0 To dimArray
    If Not mdVariables.mailFolders(I).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.mailFolders(I).EntryID) Then
                ChDir mdVariables.mailFolders(I).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.mailFolders(I).EntryID
        End If
    End If
Next I

dimArray = -1
dimArray = UBound(mdVariables.tasksFolders)
For I = 0 To dimArray
    If Not mdVariables.tasksFolders(I).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.tasksFolders(I).EntryID) Then
                ChDir mdVariables.tasksFolders(I).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.tasksFolders(I).EntryID
        End If
    End If
Next I

dimArray = -1
dimArray = UBound(mdVariables.notesFolders)
For I = 0 To dimArray
    If Not mdVariables.notesFolders(I).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.notesFolders(I).EntryID) Then
                ChDir mdVariables.notesFolders(I).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.notesFolders(I).EntryID
        End If
    End If
Next I


closeProgram_End:
    End
    
    'Exit Sub

closeProgram_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo closeProgram_End
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub
